
    .586
    .model  flat, stdcall
    option  casemap:none

    include \masm32\include\windows.inc
    include \masm32\include\kernel32.inc
    include \masm32\include\user32.inc

    includelib \masm32\lib\kernel32.lib
    includelib \masm32\lib\user32.lib

.data
;---------------------------------------
szText      DB  "dwVersion = %d.%d, dwBuild = %d, dwSP = %d.%d", 13, 10, 0

.data?
;---------------------------------------
nNumWritten DD  ?
hHandle     DD  ?
dwVersion   DD  ?
dwBuild     DD  ?
dwSP        DD  ?
buffer      DB  128 dup(?)

.code
;---------------------------------------
; GetWindowsVersionInfo
;
; Retrieves the Version, Build and Service Pack of the OS.
;
; Parameters
;---------------------------------------
; [in] dwVersion
;      Pointer to a DWORD that will contain the OS version.
; [in] dwBuild
;      Pointer to a DWORD that will contain the build info of the OS
; [in] dwServicePack
;      Pointer to a DWORD that will contail the SP level of the OS
;
; Return Value
;---------------------------------------
; If the function is successful, the return value is the OS version and the 3 input
; parameters are set accordingly; otherwise the return value is 0 and the 3 input
; parameters are also set to 0.

GetWindowsVersionInfo PROC USES esi edi, dwVersioN:PTR DWORD, dwBuilD:PTR DWORD, dwServicePack:PTR DWORD
;---------------------------------------
    LOCAL   osvi:OSVERSIONINFOEX

    xor     eax, eax
    mov     ecx, SIZEOF OSVERSIONINFOEX / 4
    lea     edi, osvi
    rep     stosd
    mov     osvi.dwOSVersionInfoSize, sizeof OSVERSIONINFOEX
    invoke  GetVersionEx, ADDR osvi
    .if eax == 0
      mov    osvi.dwOSVersionInfoSize, sizeof OSVERSIONINFO
      invoke GetVersionEx, ADDR osvi
      .if eax == 0
        mov     ecx, dwVersioN
        mov     [ecx], eax
        mov     ecx, dwBuilD
        mov     [ecx], eax
        mov     ecx, dwServicePack
        mov     [ecx], eax
        ret
      .endif
    .endif
    lea     esi, osvi
    ASSUME  esi:PTR OSVERSIONINFOEX
    mov     eax, [esi].dwMajorVersion
    mov     ecx, [esi].dwMinorVersion
    shl     eax, 16
    or      eax, ecx
    mov     ecx, dwVersioN
    mov     [ecx], eax
    mov     eax, [esi].dwBuildNumber
    mov     ecx, dwBuilD
    mov     [ecx], eax
    xor     eax, eax
    .if [esi].dwMajorVersion >= 5
      movzx   eax, WORD PTR [esi].wServicePackMajor
      movzx   ecx, WORD PTR [esi].wServicePackMinor
      shl     eax, 16
      or      eax, ecx
    .endif
    mov     ecx, dwServicePack
    mov     [ecx], eax
    mov     ecx, dwVersioN
    mov     eax, [ecx]
    ASSUME  esi:NOTHING
    ret
;---------------------------------------
GetWindowsVersionInfo ENDP

main:
;---------------------------------------
    invoke  GetStdHandle, STD_OUTPUT_HANDLE
    mov     hHandle, eax
    invoke  GetWindowsVersionInfo, addr dwVersion, addr dwBuild, addr dwSP
    movzx   eax, WORD PTR dwSP
    movzx   ecx, WORD PTR dwSP+2
    mov     edx, dwBuild
    movzx   esi, WORD PTR dwVersion
    movzx   edi, WORD PTR dwVersion+2
    invoke  wsprintf, addr buffer, addr szText, esi, edi, edx, ecx, eax
    invoke  WriteFile, hHandle, addr buffer, eax, addr nNumWritten, 0
    invoke  ExitProcess, 0
;---------------------------------------
END main
